////////////////////////////////////////////////////////////////////////////////////////////////////
// example.cpp
// Copyright(c) 2018 ozk
// This software is released under the MIT License.
// http://opensource.org/licenses/mit-license.php
////////////////////////////////////////////////////////////////////////////////////////////////////
#include "fastest_sort_w4.h"

#include <array>
#include <functional>
#include <iostream>

using namespace std;


namespace
{

	ostream &operator<<(ostream &os, const array<int, 4> &a)
	{
		return os << "{ " << a[0] << ", " << a[1] << ", " << a[2] << ", " << a[3] << " }";
	}

} // unnamed


int main()
{
	array<int, 4> data{ 3, 1, 4, 2 };
	cout << "data = " << data << std::endl;

	cout << "fsw4::sort() asc" << std::endl;
	fsw4::sort(data.begin(), data.end());
	cout << "data = " << data << std::endl;

	cout << "fsw4::sort() desc" << std::endl;
	fsw4::sort(data.begin(), data.end(), greater<>{});
	cout << "data = " << data << std::endl;

	int a = 3;
	int b = 1;
	int c = 4;
	int d = 2;
	cout << "a = " << a << ", b = " << b << ", c = " << c << ", d = " << d << std::endl;

	cout << "fsw4::sort4() asc" << std::endl;
	fsw4::sort4(a, b, c, d);
	cout << "a = " << a << ", b = " << b << ", c = " << c << ", d = " << d << std::endl;

	cout << "fsw4::sort4() desc" << std::endl;
	fsw4::sort4(a, b, c, d, greater<>{});
	cout << "a = " << a << ", b = " << b << ", c = " << c << ", d = " << d << std::endl;

	return 0;
}
